import java.io.*;
import java.util.*;

public class test {
static Hashtable curPols;

public static void parseInput(String input)
  {
    //Read a polinomial X with R(X)
    if ((input.indexOf("R") == 0)&&(input.indexOf("(") == 1)){
      String polName = input.substring(2, input.indexOf(")"));
      polynomial polVal = polynomial.readPolCof();
      curPols.put(polName, polVal);
      System.out.println("Result :"+polVal.ToString());
    }
    //X+Y
    else if (input.indexOf("+") >0){
      int plus = input.indexOf("+");
      String firstPolName = input.substring(0,plus);
      String secondPolName = input.substring(plus+1);
      System.out.println("Pols :"+firstPolName+" and "+secondPolName);
      polynomial A = (polynomial)curPols.get(firstPolName);
      polynomial B = (polynomial)curPols.get(secondPolName);
      polynomial resPol = A.addPol(B);
      System.out.println("Result :"+resPol.ToString());
    }
      //X-Y
    else if (input.indexOf("-") >0){
      int plus = input.indexOf("-");
      String firstPolName = input.substring(0,plus);
      String secondPolName = input.substring(plus+1);
      polynomial A = (polynomial)curPols.get(firstPolName);
      polynomial B = (polynomial)curPols.get(secondPolName);
      polynomial resPol = A.subPol(B);
      System.out.println("Result :"+resPol.ToString());
    }
    else if (input.indexOf("*") > 0){
      int star = input.indexOf("*");
      double constant = Double.parseDouble(input.substring(0,star));
      polynomial A = (polynomial)curPols.get(input.substring(star+1));
      polynomial resPol = A.multPol(constant);
      System.out.println("Result :"+resPol.ToString());
    }
    else if (input.indexOf("val(") >=0){
      int closePar = input.indexOf(")");
      String polName = input.substring(4, closePar);
      polynomial resPol = (polynomial)curPols.get(polName);
      System.out.println("Result :"+resPol.ToString());
    }
  }


public static void main(String []args)
  {
    boolean flag=false;
    curPols = new Hashtable();

    System.out.println("Type R(X) to read, X+Y and X-Y to add and substract");
    System.out.println("Type c*X to multiply X with c and val(X) to print X");
    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

    try{
      while(!flag){
	String input = br.readLine();
	parseInput(input);
      }
    }catch(IOException ioexc){System.out.println("Excp:"+ioexc);}
    
  }




}
